"
 COPYRIGHT (c) 2005 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:libbasic' }"

Object subclass:#PluginSupport
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-Support'
!

!PluginSupport class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2005 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Provides support functions to run stx in a browser window as a plugin.
    (actually, it could be started from any other application just the same...)

    [author:]
	Claus Gittinger

    [see also:]
	Smalltalk
"
! !

!PluginSupport class methodsFor:'support'!

setPluginWindowHandle:windowId
%{
    extern void __pluginSetWindow();
#   define HWND         void *
#   define _HWNDVal(o)  (HWND)(__MKCP(o))

    if (__isExternalAddress(windowId)) {
	HWND hWnd = _HWNDVal(windowId);
	__pluginSetWindow(hWnd);
    }
%}.
! !

!PluginSupport class methodsFor:'startup'!

start:anApplicationClass inWindowWithID:windowID parameters:parameters
    |app v browserWindow|

    browserWindow := ExternalTopView newWithID:windowID.
    browserWindow viewBackground:(Color red).
    browserWindow clear.

    (anApplicationClass isSubclassOf:ApplicationModel) ifTrue:[
	app := anApplicationClass new.
	app allButOpen.
	browserWindow becomeParentOf:app window.
	"/ app window extent:1.0@1.0.
	self setPluginWindowHandle:(app window id).
    ] ifFalse:[
	v := anApplicationClass new.
	browserWindow becomeParentOf:v.
    ].

    "/ wait forEver
"/    Semaphore new wait.
!

startInBrowserWithWindowID:windowID parameters:parameters
    self
	start:(WorkspaceApplication ? Workspace)
	inWindowWithID:windowID
	parameters:parameters

    "
     |v|

     v := StandardSystemView new.
     v openAndWait.
     self startInBrowserWithWindowID:v id parameters:#().
    "

    "
     |v app|

     v := StandardSystemView new.
     v create.
     app := WorkspaceApplication new.
     app window:v.
     app allButOpen.
     app openWindow.
    "
! !

!PluginSupport class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/PluginSupport.st,v 1.7 2005-12-21 19:52:45 cg Exp $'
! !
